import datetime
from CRC import *
import rssiConvert as rc

#RFID 协议解析

LogoAnswer=[]#登录成功的ip集合
v=2#通信版本号

def head_data(v,id):
    head= bytearray('DSRF',encoding='ascii')
    v=bytearray([v])
    head=head+v
    id=bytearray([id])
    head=head+id
    return head

def logon_data():#登录消息数据
    head=head_data(v,1)
    name=bytearray(b'admin')+bytearray(11)
    pwd=bytearray(b'888888')+bytearray(10)
    data=name+pwd
    l=bytearray([0,len(data)])
    crcdata=CRC16(l+data,len(l+data))
    crc=bytearray([crcdata>>8,crcdata&0xff])
    msg_data=head+crc+l+data
    return msg_data

def heartbeat_data():#心跳数据
    head=head_data(v,4)
    data=bytearray(2)
    l=bytearray([0,len(data)])
    crcdata=CRC16(l+data,len(l+data))
    crc=bytearray([crcdata>>8,crcdata&0xff])
    msg_data=head+crc+l+data
    return msg_data

#*
# slot 分站号
# id 标签id
# seconds 呼叫时间 单位s
# mode 呼叫模式 0:绿灯光 1:绿灯光+声音 2:红灯闪烁 3:红灯+声音 4:红绿交替闪烁 5:红绿交替闪烁+声音 255:停止提醒
#*#
def calltag_data(slot,id,seconds,mode):#呼叫标签数据
    head=head_data(v,6)
    slt=bytearray([slot])
    i= (id).to_bytes(4, 'big')
    se=bytearray([seconds])
    mo=bytearray([mode])
    data=slt+i+se+mo
    l=bytearray([0,len(data)])
    crcdata=CRC16(l+data,len(l+data))
    crc=bytearray([crcdata>>8,crcdata&0xff])
    msg_data=head+crc+l+data
    return msg_data


def callmsgtag_data(slot,id,msg_str):#短信标签数据
    head=head_data(v,9)
    slt=bytearray([slot])
    i= (id).to_bytes(4, 'big')
    msg_num=bytearray([0,0])
    y= bytearray([datetime.datetime.today().year-2020])
    m= bytearray([datetime.datetime.today().month])
    d= bytearray([datetime.datetime.today().day])
    h= bytearray([datetime.datetime.today().hour])
    mi= bytearray([datetime.datetime.today().minute])
    s= bytearray([datetime.datetime.today().second])
    data=slt+i+msg_num+y+m+d+h+mi+s
    msg_da= msg_str.encode('gbk')
    print(msg_da) 
    msg_da_len=len(msg_da)
    l=bytearray([msg_da_len])
    data=data+l
    if msg_da_len>110:
        msg_da=msg_da[0:110] 
    if msg_da_len<110:
        msg_da=msg_da+bytearray(110-msg_da_len)
    data=data+msg_da
    l=bytearray([0,len(data)])
    crcdata=CRC16(l+data,len(l+data))
    crc=bytearray([crcdata>>8,crcdata&0xff])
    msg_data=head+crc+l+data
    return msg_data

def logo_on_ack(c_client,data):#收到登录消息反馈
    value= int.from_bytes(data,'big')
    if value==0:
        if LogoAnswer.count(c_client)==0:
            LogoAnswer.append(c_client)
        print(str(c_client)+"logo Succsess")
    else:
        print(str(c_client)+"logo Error")


def recvTagData(c_client,data,data_len):#收到电子标签数据
    slot=data[0]
    id= data[4]|(data[3] << 8)|(data[2] << 16)|(data[1] << 24)
    attri=data[5]
    volt=attri&1
    tag_type=(attri&14)>>1
    keep=(attri&16)>>4
    extend_len=(attri&224)>>5
    rs=data[data_len-1]
    extend_data=0
    if rs>127:
        rs=rs-256
    if extend_len>0:
        extend_data=data[6:data_len-1]
    dis=rc.rssi2Distant(rs)
    tag_dict=dict(Slot=slot,ID=id,RSSI=rs,DIS=dis,Type=tag_type,Attribute=attri,extend_len=extend_len,extend_data=extend_data)
    return tag_dict
    #print(tag_dict)
    

def heartbeat_ack(c_client,data):#收到心跳数据ack
    slotSum=data[0]
    print(str(c_client)+':'+str(slotSum)+':'+str(data))


def calltag_ack(data):#收到呼叫电子标签ack
    slot=data[0]
    id= data[4]|(data[3] << 8)|(data[2] << 16)|(data[1] << 24)
    print ("ack:"+str(slot)+':'+str(id))


def calltag_reject(data):#收到呼叫电子标签reject
    print('reject')
    print(data)

def callmsgtag_ack(data):#收到发送短信电子标签ack
    slot=data[0]
    id= data[4]|(data[3] << 8)|(data[2] << 16)|(data[1] << 24)
    print ("ack:"+str(slot)+':'+str(id))


def callmsgtag_reject(data):#收到发送短信电子标签reject
    slot=data[0]
    id= data[4]|(data[3] << 8)|(data[2] << 16)|(data[1] << 24)
    reject=data[5]
    print('reject:')
    print (str(slot)+str(id)+str(reject))
